/*
 ** Created on 2020/05/07.
 */
#include <stdbool.h>
#include <elf_sign.h>
#ifndef _DEB_SIGN_H
#define _DEB_SIGN_H
#ifdef __cplusplus
extern "C" {
#endif
typedef struct sof_ctx_t sof_ctx_t;

#define TEMP_CERT            "/tmp/_keylin.crt"

#define SIGN_FILE            "_kylin.sig"
#define CERT_FILE            "_kylin.crt"
enum SignModel
{
    ca_moclose=1, ca_warning, ca_prevent
};
enum interface_auth_result {
        IF_AUTH_UNKNOWN = -1,   /* 未知认证结果，表示还没进行认证 */
        IF_AUTH_SUCCESS = 0,    /* 认证成功 */
        IF_AUTH_FAILED,         /* 认证失败 */
        IF_AUTH_ERROR           /* 认证出错 */
};

#define interface_control_file "/etc/kylinsign/interface_control.conf"
/* 当@inner值为1时，表示内部接口认证，此时@hash需要填充正确的hash值
 * 当@inner值不为1时，表示外部接口认证，此时@hash可以为NULL */
int kysec_interface_authentication(int inner, unsigned char *hash,AU_get *AUresult);
int get_cert_sec_type(char *outd);
int getCertSecType(char *CertSecType,const char *user_cert);
int control_dpkg_file(int type);
void output_error_msg(int ret);
int change_interface_control_conf(char *newstring);
char *getOuPath(const char *path);
int getDebCert(const char *deb);
int operatesign(char *buf,int len,int num);
void getnext(char t[], int next[]);
int certKMP(char *certfile);
int getDebCertNum(const char *deb,char *oname,int num);
int getDebCertSerNum(const char *deb,char *user_cert);
int doDebVerify2(const char *deb,char *oname,bool isinstall);
int doDebVerifyall(const char *deb,bool isinstall);
int doDebSign(const char *deb, const char *certPath, const char *pkey_file);
int Multiple_doDebSign(const char *deb, const char *certPath, const char *pkey_file);
int doDebVerify(const char *deb);
int getAllOu(const char *deb,char *ouchain);
int getFirstDebCert(const char *deb);
int getFirstCertSecType(const char *deb,char *CertSecType);
int getIssuerST(const char *deb,char *IssuerST);
int getSubjectO(const char *deb,char *SubjectO);
int getSubjectOU(const char *deb,char *SubjectOU);
int getIssuerOU(const char *deb,char *IssuerOU);
int getSubjectCN(const char *dev,char *SubjectCN);
int SignPackageAll(const char *debPath, const char *certPath, const char *pkey_file);
int  SignPackageAllElf(const char *debPath, const char *certPath, const char *pkey_file);
int findElfSign(const char *path, int recursive, const char *certPath, const char *pkey_file);
int findDebSign(const char *path, int recursive, const char *certPath, const char *pkey_file);
int deleteElfSign(const char *path, int recursive);
extern int GetConfigValue(const char * confPath, char * optionName, char *optionData, unsigned int optionDataLen);
int verifybfsign(const char * deb,const char *certPath,const char * signPath);
int verify_cert_valid(sof_ctx_t *ctx);
int DelPackageAll(const char *debPath);
int dodebsign(sof_ctx_t *ctx, const char *deb);
int multiple_dodebsign(sof_ctx_t *ctx, const char *deb);
int  signpackageall( sof_ctx_t *ctx, const char *deb);
int  signpackageallelf(sof_ctx_t *ctx, const char *deb);
int dodebverifyall(sof_ctx_t *ctx, const char *deb, bool isinstall);
void usb_change_callback(void* ctx, int action);
int dodebverify2(sof_ctx_t *ctx, const char *deb,char *oname,bool isinstall);
int findelfsign(const char *path, int recursive, const char *certPath, sof_ctx_t *ctx);
int finddebsign(const char *path, int recursive, const char *certPath, sof_ctx_t *ctx);
int BJCA_dodebverify(sof_ctx_t *ctx, const char *deb, bool isinstall);
int getDebCertAllInfo(const char *deb,char *info,char *CertObject);
int getAllIssuerST(const char *deb,char *IssuerST);
int getAllIssuerOU(const char *deb,char *IssuerOU);
int getAllSubjectOU(const char *deb,char *SubjectOU);
int getAllSubjectO(const char *deb,char *SubjectO);
int getAllSubjectCN(const char *deb,char *SubjectCN);
int getAllCertSecType(const char *deb,char *CertSecType);
int getCertNumber(const char *deb);
int BJCA_base_dodebverify(sof_ctx_t *ctx, const char *deb, bool isinstall);

int BJCA_apkverify(const char *filename);

//int getIssuerST(const char *deb,char *IssuerST,const char *user_cert,int bio_type);
#ifdef __cplusplus
}
#endif
#endif //_DEB_SIGN_H
